/*
 ---------------------------------------------------------------
 Copyright (c) 2006, ixi software.
 This work is licensed under a Creative Commons 
 Attribution-NonCommercial-ShareAlike 2.0 England & Wales License.
 http://creativecommons.org/licenses/by-nc-sa/2.0/uk/
 --------------------------------------------------------------- 
 */
 
 
 /* we learn here how instances of classes can e initialised with different values
 that are passed to the 'constructor' method
 */


CircleBounce c, d;

void setup() { // just when starting up
  frameRate(20); // fps
  size(300, 200); // window size
  background(100); // bg color
  noStroke();
  //changeColor();
  
  c = new CircleBounce(100, 100, 40, 20, color(255, 255,255));
  
  d = new CircleBounce(200, 10, 10, 40, color(255, 0,0));
}


color randRGB(){ // returns data type color
  return color(random(255), random(255), random(255));
}


void draw(){ // this is our main loop
  background(100);
  c.circleBounceDraw();
  d.circleBounceDraw();
}


class CircleBounce{
  float x;
  float y;
  float w;
  float h;
  float deltaX = random(1,5);
  float deltaY = random(1,5);
  color c; // just declare because we are going to initialise it as a parameter

  CircleBounce(float ax, float ay, float aw, float ah, color aColor){ 
  // this is the constructor of the class, up to now it was hidden because we didnt need it
    x = ax;
    y = ay;
    w = aw;
    h = ah;
    c = aColor; // property c takes the value passed via parameter aColor when initialising the class instance
  }

  void changeMyColor(){
    c = randRGB();
  }

  void circleBounceDraw(){
    fill(c); // asign my color
    ellipse(x, y, w, h);
    
    x = x + deltaX; 
    y = y + deltaY; 
    if (x >= 300 || x <= 0){
      deltaX = -deltaX; //change X direction
      changeMyColor();
    }
    if (y >= 200 || y <= 0){
      deltaY = -deltaY; //change Y direction
      changeMyColor();
    }
  }
}


